      subroutine setupmatrix (matpar,rhs,x)
      implicit none
 
      integer matpar(*)
      double precision rhs(*), x(*)
c=============declarations for problem definition=======================
c-------------parameters------------------------------------------------

      integer             nmat_max
      parameter         ( nmat_max = 1 00 000 )
      integer             nzero_max
      parameter         ( nzero_max = 1 000 000 )
      integer             col_s(nzero_max), rpt_s(nmat_max+1)
      double precision    val_s(nzero_max) 
      double precision    rhs_s(nmat_max), x_s(nmat_max)

      INCLUDE "include_parameters"
c------------- data structure for distributed matrix in 
c------------- global address space 
      integer             col(matlen), rpt(veclen+1)
      real                val(matlen)
      common            / matrix / val, col, rpt

      integer             nzero
      integer             nmat,nproc, ierr

c------------- local variables

      integer firstrow_on_proc(proclen+1)
      integer firstrow, firstval, nloc, nloc1, nzloc
      integer firstrowp, firstvalp, nlocp, nzlocp
      integer i, ip, mypid, l, la, nnz

      matpar(21) = 0
      nproc = matpar(11)
      mypid = matpar(12)

      if (nproc.gt.proclen) then 
         if (mypid.eq.0) then
            write(6,*) 'nproc =',nproc,' is too large'
            write(6,*) 'maximal value is proclen =',proclen
         end if
         call lib_barrier()
         matpar(21) = -1
         return
      end if

      call lib_barrier()

      if (mypid.eq.0) then
         open (90, file = 'matrix.fcc', status = 'old')
         read (90,*) nmat
         if (nmat.gt.nmat_max) then
            write (6,*) 'nmat =',nmat,' is too large'
            write (6,*) 'maximal value is nmat_max =',nmat_max
            matpar(21) = -1
            go to 111
         end if
         rpt_s(1) = 1
         do i = 1 , nmat
            la = rpt_s(i)
            read (90,*) nnz,(val_s(l),col_s(l),l=la,la+nnz-1)
            rpt_s(i+1) = la + nnz
            nzero = rpt_s(i+1) - 1
            if (nzero.gt.nzero_max) then
               write (6,*) 'nzero =',nzero,' is too large'
               write (6,*) 'maximal value is nzero_max =',nzero_max
               matpar(21) = -1
               go to 111
            end if
         end do
         do l = 1 , nzero
            col_s(l) = col_s(l) + 1
         end do
         call distribute_index(nmat,nproc,firstrow_on_proc)
         write(6,*)'distribution',(firstrow_on_proc(i),i=1,nproc+1)
 111     continue
      end if
      call lib_barrier()
      call lib_brdcst_i(matpar(21),1,0,ierr)
      if (matpar(21).lt.0) return

      call lib_brdcst_i(nmat,1,0,ierr)
      call lib_brdcst_i(firstrow_on_proc,nproc+1,0,ierr)

      do ip = 0 , nproc-1
         if (mypid.eq.0) then
            firstrowp = firstrow_on_proc(ip+1)
            nlocp = firstrow_on_proc(ip+2) - firstrow_on_proc(ip+1) 
            firstvalp = rpt_s(firstrowp)
            nzlocp = rpt_s(firstrowp+nlocp) - rpt_s(firstrowp)
         end if
         call lib_p2p_s(val_s(firstvalp),nzlocp,0,
     :                       val,nzloc,ip,ierr)
         call lib_p2p_i(col_s(firstvalp),nzlocp,0,
     :                       col,nzloc,ip,ierr)
         call lib_p2p_i(rpt_s(firstrowp),nlocp+1,0,
     :                       rpt,nloc1,ip,ierr)
         nloc = nloc1 - 1
      end do

c----------- let rpt point to the _local_ row indices  
c----------- of the individual processors
      firstval = rpt(1)
      do i = 1, nloc+1
         rpt(i) = rpt(i) - firstval+1
      end do

      matpar(2) = nmat
      matpar(13) = nloc
      matpar(14) = nzloc
      matpar(15) = firstrow_on_proc(mypid+1)


      return 
      end 


      subroutine distribute_index(nmat,nproc,firstrow_on_proc)
      implicit none
      integer nmat, nproc, firstrow_on_proc(*)

      integer nloc, nproc1, ip
      firstrow_on_proc(1) = 1

      nloc = (nmat+nproc-1) / nproc
      nproc1 = nloc*nproc - nmat
      do ip = 1 , nproc-nproc1
         firstrow_on_proc(ip+1) = firstrow_on_proc(ip) + nloc
      end do
      do ip = nproc-nproc1+1 , nproc
         firstrow_on_proc(ip+1) = firstrow_on_proc(ip) + nloc-1
      end do

      return
      end

