      subroutine setupmatrix (matpar,rhs,x)
      implicit none
c=====7==1=========2=========3=========4=========5=========6=========7==
      integer matpar(*)
      real             rhs(*), x(*) 


      INCLUDE "include_parameters"
c------------- data structure for distributed matrix in 
c------------- global address space 
      integer             col(matlen), rpt(veclen+1)
      real                val(matlen)
      common            / matrix / val, col, rpt

      real             amult
      parameter ( amult   = 1220703125.0D0 )

      integer nmat, nzr, nspread, nproc, mypid

      integer firstrow, nloc, nzloc, firstrow_on_proc(proclen) 
      integer nzr_max
      parameter (nzr_max = 1000)
      real             randlc, randseed, value, diag_value
      parameter (value = 0.3, diag_value = 1.0)

      integer temp(nzr_max+1), nr2, tempa, iset, l, ind, i, k
      integer iloc, irep, k1

      nmat = matpar(2)
      nzr = matpar(3)
      nspread = matpar(4)
      nproc = matpar(11)
      mypid = matpar(12)

      if (nzr.gt.nzr_max) then
         write(6,*)
     : nzr,' too many nonzeros per row, only ',nzr_max,' allowed'
         matpar(21) = -5
         return
      end if
      if (nzr.gt.nmat) nzr = nmat
      if (nspread.lt.0) nspread = nmat
      if (nspread.lt.2*nzr) nspread = 2*nzr
      if (nspread.gt.nmat) nspread = nmat

      call distribute_index(nmat,nproc,firstrow_on_proc)
      firstrow = firstrow_on_proc(mypid+1)
      nloc = firstrow_on_proc(mypid+2) - firstrow_on_proc(mypid+1) 

      if (nloc.gt.veclen) then
         write(6,*)
     :    'not enough local space for local parts of vectors'
         write(6,*)'nloc = ',nloc,' veclen_loc = ',veclen
         matpar(21) = -1
         return
      end if
      if (nzr*nloc.gt.matlen) then
         write(6,*)
     :    'not enough local space for local parts of matrix'
         write(6,*)'nzloc = ',nzr*nloc,' matlen_loc = ',matlen
         matpar(21) = -2
         return
      end if

c----------- rhs and start vectors in distributed global adress space 
      do i = 1 , nloc
            rhs(i) = real(firstrow-1+i) 
            x(i) = 0.0
      end do

      nr2 = nspread / 2
      nzr = nzr - 1
      rpt(1) = 1
      l = 1
      do iloc = 1 , nloc
         i = firstrow + iloc-1
         if (i.le.nr2)  then
            iset = 0
         else if (i.ge.nmat-nr2-1) then
            iset = nmat - nspread
         else
            iset = i - nr2
         end if
         temp(1) = i - iset
         randseed = dble(23456*i)+3141592659987.0D0  
         do k = 2 , nzr + 1
            do irep = 1 , 100
               ind = 1 + nspread * randlc(randseed,amult)
               do k1 = 1,k-1
                  if (ind.eq.temp(k1)) go to 10
               end do
               go to 20
   10          continue
            end do
   20       continue 
            temp(k) = ind
         end do
         call sorter(nzr+1,temp)
 1111    format(20i3)
         tempa = temp(1)
         col(l) = iset+temp(1)
         val(l) = value
         if (col(l).eq.i) val(l) = diag_value
         l = l + 1
         do k = 2 , nzr+1
            if (temp(k).ne.tempa) then         
               col(l) = iset + temp(k)
               val(l) = value
               if (col(l).eq.i) val(l) = diag_value
               l = l + 1
            end if
            tempa = temp(k)
         end do
         rpt(iloc+1) = l
      end do

      nzloc = rpt(1+nloc) - rpt(1) 


      matpar(13) = nloc
      matpar(14) = nzloc
      matpar(15) = firstrow

      return
      end

      subroutine sorter(n,a)
      integer n, a(n)
      integer keepi, keepj, i, j
      do  i = 1, n
         keepi = a(i)
         do  j = i + 1, n
            if (a(j) .lt. keepi) then
               keepj    = keepi
               keepi = a(j)
               a(j) = keepj
            end if
         end do
         a(i) = keepi
      end do
     
      return
      end

      subroutine distribute_index(nmat,nproc,firstrow_on_proc)
      implicit none
      integer nmat, nproc, firstrow_on_proc(*)

      integer nloc, nproc1, ip
      firstrow_on_proc(1) = 1

      nloc = (nmat+nproc-1) / nproc
      nproc1 = nloc*nproc - nmat
      do ip = 1 , nproc-nproc1
         firstrow_on_proc(ip+1) = firstrow_on_proc(ip) + nloc
      end do
      do ip = nproc-nproc1+1 , nproc
         firstrow_on_proc(ip+1) = firstrow_on_proc(ip) + nloc-1
      end do
c      do ip = 2 , nproc
c         firstrow_on_proc(ip) = firstrow_on_proc(ip-1) + ip
c      end do
c      firstrow_on_proc(nproc+1) = nmat + 1
      return
      end

      FUNCTION RANDLC (X, A)
C
C   This routine returns a uniform pseudorandom real             number in the
C   range (0, 1) by using the linear congruential generator
C
C   x_{k+1} = a x_k  (mod 2^46)
C
C   where 0 < x_k < 2^46 and 0 < a < 2^46.  This scheme generates 2^44 numbers
C   before repeating.  The argument A is the same as 'a' in the above formula,
C   and X is the same as x_0.  A and X must be odd real             integers
C   in the range (1, 2^46).  The returned value RANDLC is normalized to be
C   between 0 and 1, i.e. RANDLC = 2^(-46) * x_1.  X is updated to contain
C   the new seed x_1, so that subsequent calls to RANDLC using the same
C   arguments will generate a continuous sequence.
C
C   This routine should produce the same results on any computer with at least
C   48 mantissa bits in real             floating point data.  On Cray systems,
C   real             should be disabled.
C
C   David H. Bailey     October 26, 1990
C
      IMPLICIT REAL*8 (A-H, O-Z)
      INTEGER KS, I
      SAVE KS, R23, R46, T23, T46
      DATA KS/0/
C
C   If this is the first call to RANDLC, compute R23 = 2 ^ -23, R46 = 2 ^ -46,
C   T23 = 2 ^ 23, and T46 = 2 ^ 46.  These are computed in loops, rather than
C   by merely using the ** operator, in order to insure that the results are
C   exact on all systems.  This code assumes that 0.5D0 is represented exactly.
C
      IF (KS .EQ. 0) THEN
        R23 = 1.D0
        R46 = 1.D0
        T23 = 1.D0
        T46 = 1.D0
C
        DO 100 I = 1, 23
          R23 = 0.5D0 * R23
          T23 = 2.D0 * T23
 100    CONTINUE
C
        DO 110 I = 1, 46
          R46 = 0.5D0 * R46
          T46 = 2.D0 * T46
 110    CONTINUE
C
        KS = 1
      ENDIF
C
C   Break A into two parts such that A = 2^23 * A1 + A2 and set X = N.
C
      T1 = R23 * A
      A1 = AINT (T1)
      A2 = A - T23 * A1
C
C   Break X into two parts such that X = 2^23 * X1 + X2, compute
C   Z = A1 * X2 + A2 * X1  (mod 2^23), and then
C   X = 2^23 * Z + A2 * X2  (mod 2^46).
C
      T1 = R23 * X
      X1 = AINT (T1)
      X2 = X - T23 * X1
      T1 = A1 * X2 + A2 * X1
      T2 = AINT (R23 * T1)
      Z = T1 - T23 * T2
      T3 = T23 * Z + A2 * X2
      T4 = AINT (R46 * T3)
      X = T3 - T46 * T4
      RANDLC = R46 * X
C
      RETURN
      END
