      subroutine lib_initialize(nproc,mypid,ierr)
      implicit none
      integer nproc, mypid, ierr
      INCLUDE "mpif.h"

      call MPI_INIT( ierr )

      call MPI_COMM_SIZE( MPI_COMM_WORLD, nproc, ierr )
      call MPI_COMM_RANK( MPI_COMM_WORLD, mypid, ierr )

c         write(6,*)'mypid',mypid,' of',nproc,' processes'

      return
      end

      subroutine lib_finalize(nproc,mypid,ierr)
      implicit none
      integer nproc, mypid, ierr
      INCLUDE "mpif.h"

      call MPI_FINALIZE( ierr )

      return
      end

      subroutine lib_brdcst_i(data,n,root,ierr)
      implicit none
      integer              data(*)
      integer              n, root, ierr
      INCLUDE "mpif.h"

      integer              ia, i, rp, nproc, ip 

      call MPI_COMM_SIZE( MPI_COMM_WORLD, nproc, ierr )
      call MPI_COMM_RANK( MPI_COMM_WORLD, ip, ierr )

      call MPI_BCAST( data, n, MPI_INTEGER, root, 
     :                MPI_COMM_WORLD, ierr )

      return
      end

      subroutine lib_brdcst_s(data,n,root,ierr)
      implicit none
      real                 data(*)
      integer              n, root, ierr
      INCLUDE "mpif.h"

      integer              ia, i, rp, nproc, ip 

      call MPI_COMM_SIZE( MPI_COMM_WORLD, nproc, ierr )
      call MPI_COMM_RANK( MPI_COMM_WORLD, ip, ierr )

      call MPI_BCAST( data, n, MPI_REAL, root, 
     :                MPI_COMM_WORLD, ierr )

      return
      end

      subroutine lib_p2p_i(data_s,n_s,ip_s,data_r,n_r,ip_r,ierr)
      implicit none
      integer              data_s(*), data_r(*)
      integer              n_s, n_r, ip_s, ip_r, ierr
      integer              mypid, i
      INCLUDE "mpif.h"
      integer status(MPI_STATUS_SIZE)

      call MPI_COMM_RANK( MPI_COMM_WORLD, mypid, ierr )
      if (ip_s.eq.ip_r) then
         if (mypid.eq.ip_s) then
            n_r = n_s
            do i = 1 , n_r
               data_r(i) = data_s(i)
            end do
         end if
      else
         if (mypid.eq.ip_s) then
            call MPI_SEND( n_s, 1, MPI_INTEGER, ip_r,
     :                     12, MPI_COMM_WORLD, ierr ) 
         else if (mypid.eq.ip_r) then
            call MPI_RECV( n_r, 1, MPI_INTEGER, ip_s,
     :                     12, MPI_COMM_WORLD, status, ierr )
         end if
         call MPI_BARRIER( MPI_COMM_WORLD, ierr )
         if (mypid.eq.ip_s) then
            call MPI_SEND( data_s, n_s, MPI_INTEGER, ip_r,
     :                     13, MPI_COMM_WORLD, ierr ) 
         else if (mypid.eq.ip_r) then
            call MPI_RECV( data_r, n_r, MPI_INTEGER, ip_s,
     :                     13, MPI_COMM_WORLD, status, ierr )
         end if
      end if
      call MPI_BARRIER( MPI_COMM_WORLD, ierr )

      return
      end

      subroutine lib_p2p_s(data_s,n_s,ip_s,data_r,n_r,ip_r,ierr)
      implicit none
      real                 data_s(*), data_r(*)
      integer              n_s, n_r, ip_s, ip_r, ierr
      integer              mypid, i
      INCLUDE "mpif.h"
      integer status(MPI_STATUS_SIZE)

      call MPI_COMM_RANK( MPI_COMM_WORLD, mypid, ierr )
      if (ip_s.eq.ip_r) then
         if (mypid.eq.ip_s) then
            n_r = n_s
            do i = 1 , n_r
               data_r(i) = data_s(i)
            end do
         end if
      else
         if (mypid.eq.ip_s) then
            call MPI_SEND( n_s, 1, MPI_INTEGER, ip_r,
     :                     12, MPI_COMM_WORLD, ierr ) 
         else if (mypid.eq.ip_r) then
            call MPI_RECV( n_r, 1, MPI_INTEGER, ip_s,
     :                     12, MPI_COMM_WORLD, status, ierr )
         end if
         call MPI_BARRIER( MPI_COMM_WORLD, ierr )
         if (mypid.eq.ip_s) then
            call MPI_SEND( data_s, n_s, MPI_REAL, ip_r,
     :                     13, MPI_COMM_WORLD, ierr ) 
         else if (mypid.eq.ip_r) then
            call MPI_RECV( data_r, n_r, MPI_REAL, ip_s,
     :                     13, MPI_COMM_WORLD, status, ierr )
         end if
      end if
      call MPI_BARRIER( MPI_COMM_WORLD, ierr )

      return
      end

      subroutine lib_a2a_i(data_s,n_s,ip_s,data_r,n_r,ip_r,ierr)
      implicit none
      integer              data_s(*), data_r(*)
      integer              n_s, n_r, ip_s, ip_r, ierr
      integer              mypid
      INCLUDE "mpif.h"
      integer status(MPI_STATUS_SIZE)

      call MPI_COMM_RANK( MPI_COMM_WORLD, mypid, ierr )
      if (ip_s.ge.0)
     :   call MPI_SEND( n_s, 1, MPI_INTEGER, ip_s,
     :                  12, MPI_COMM_WORLD, ierr ) 
      if (ip_r.ge.0)
     :   call MPI_RECV( n_r, 1, MPI_INTEGER, ip_r,
     :                  12, MPI_COMM_WORLD, status, ierr )

      call MPI_BARRIER( MPI_COMM_WORLD, ierr )
 
      if (ip_s.ge.0)
     :   call MPI_SEND( data_s, n_s, MPI_INTEGER, ip_s,
     :                  13, MPI_COMM_WORLD, ierr ) 
      if (ip_r.ge.0)
     :   call MPI_RECV( data_r, n_r, MPI_INTEGER, ip_r,
     :                  13, MPI_COMM_WORLD, status, ierr )

      call MPI_BARRIER( MPI_COMM_WORLD, ierr )

      return
      end

      subroutine lib_globmax_i(data,res,n,root,ierr)
      implicit none

      integer            data(*), res(*)
      integer            n, root, ierr
      INCLUDE "mpif.h"

      call MPI_REDUCE( data, res, n, MPI_INTEGER, MPI_MAX, root,
     :                 MPI_COMM_WORLD, ierr )

      return
      end

      subroutine lib_globmax_s(data,res,n,root,ierr)
      implicit none

      real               data(*), res(*)
      integer            n, root, ierr
      INCLUDE "mpif.h"

      call MPI_REDUCE( data, res, n, MPI_REAL, MPI_MAX, root,
     :                 MPI_COMM_WORLD, ierr )

      return
      end

      subroutine lib_globmin_i(data,res,n,root,ierr)
      implicit none

      integer            data(*), res(*)
      integer            n, root, ierr
      INCLUDE "mpif.h"

      call MPI_REDUCE( data, res, n, MPI_INTEGER, MPI_MIN, root,
     :                 MPI_COMM_WORLD, ierr )

      return
      end

      subroutine lib_globmin_s(data,res,n,root,ierr)
      implicit none

      real               data(*), res(*)
      integer            n, root, ierr
      INCLUDE "mpif.h"

      call MPI_REDUCE( data, res, n, MPI_REAL, MPI_MIN, root,
     :                 MPI_COMM_WORLD, ierr )

      return
      end

      subroutine lib_globsum_i(data,res,n,root,ierr)
      implicit none

      integer            data(*), res(*)
      integer            n, root, ierr
      INCLUDE "mpif.h"

      call MPI_REDUCE( data, res, n, MPI_INTEGER, MPI_SUM, root,
     :                 MPI_COMM_WORLD, ierr )

      return
      end


      subroutine lib_barrier()
      INCLUDE "mpif.h"

      call MPI_BARRIER( MPI_COMM_WORLD, ierr )

      return 
      end








      real function lib_timer()
      implicit none
      INCLUDE "mpif.h"

      lib_timer = MPI_WTIME()

      return
      end
