      subroutine matvec_ini(ipar,diag)
      implicit none

      integer  ipar(*), diag(*)
c=============declarations for problem definition=======================
c-------------parameters------------------------------------------------
      INCLUDE "include_parameters"
c------------- data structure for distributed matrix in 
c------------- global address space 
      integer             col(matlen), rpt(veclen+1)
      real                val(matlen)
      common            / matrix / val, col, rpt
c------------- data structure for externel variables in 
c------------- global address space 
      integer             get_list(extlen), get_id(proclen), 
     :                    get_pt(proclen), get_nb(proclen), nget
      integer             put_list(extlen), put_id(proclen),
     :                    put_pt(proclen), put_nb(proclen), nput
      common   / extern / get_list, get_id, get_pt, get_nb, nget, 
     :                    put_list, put_id, put_pt, put_nb, nput

c------------- local variables
      integer veclen_loc, nmat, nzloc, nproc, mypid, nloc, firstrow
      integer firstrow_on_proc(proclen+1)
      integer nd, nspread, nspread_sum, nspread_min, nspread_max, ncom
      integer nzero, nzero_sum, nzero_min, nzero_max
      integer j, l, jp, jpm, cl, cl_loc, lv_sjp, nlocjp
      real t1, t2, t3, t4, t5, t6, lib_timer

      call lib_barrier()
      t1 = lib_timer()
      diag(1) = 0

      nmat = ipar(2)
      nproc = ipar(6)
      mypid = ipar(7)
      if (nproc.gt.proclen) then 
         if (mypid.eq.0) then
            write(6,*) 'nproc =',nproc,' is too large'
            write(6,*) 'maximal value is proclen =',proclen
         end if
         call lib_barrier()
         diag(1) = -1
         return
      end if

      nloc = ipar(4)
      veclen_loc = veclen 

      nzloc =rpt(1+nloc) - rpt(1) 

      call vars_on_proc(nproc,mypid,nloc,firstrow_on_proc)
      firstrow = firstrow_on_proc(mypid+1)
      nspread_sum = 0
      nspread_max = 0
      nspread_min = nmat
      nzero_sum = 0
      nzero_max = 0
      nzero_min = nmat
      do j = 1 , nloc
      nspread = 0
         do l = rpt(j) , rpt(j+1)-1
            nd = iabs(firstrow+j-1 - col(l))
            if (nd.gt.nspread) nspread = nd
         end do
      nzero = rpt(j+1) - rpt(j)
      nzero_sum = nzero_sum + nzero
      if (nzero.lt.nzero_min) nzero_min = nzero
      if (nzero.gt.nzero_max) nzero_max = nzero
      nspread_sum = nspread_sum + nspread
      if (nspread.gt.nspread_max) nspread_max = nspread
      if (nspread.lt.nspread_min) nspread_min = nspread
      end do
      diag(2) = nzero_sum
      diag(3) = nzero_min
      diag(4) = nzero_max
      diag(5) = nspread_sum
      diag(6) = nspread_min
      diag(7) = nspread_max

c----------- let col point to vector elements in 
c----------- distributed global adress space: 
c----------- A column index cl can be split: cl = lv_sjp + cl_loc
c----------- where lv_sjp is the number of elements with index < cl 
c----------- on remote processors and cl_loc the number of local 
c----------- elements with index <= cl, which reside on processor jp.
      ncom = 0
      do l = 1 , nzloc
         cl = col(l) 
         lv_sjp = 0
         do jp = 0 , nproc-1
            nlocjp = firstrow_on_proc(jp+2) - firstrow_on_proc(jp+1)
            if(lv_sjp+nlocjp.ge.cl) then
               cl_loc = cl - lv_sjp
               go to 100
            end if
            lv_sjp = lv_sjp + nlocjp
         end do
  100    continue
         col(l) = jp*veclen_loc + cl_loc
         if (jp.ne.mypid) ncom = ncom + 1
      end do
      diag(8) = ncom
      call lib_barrier()
      t2 = lib_timer()
      call get_pattern(nproc,mypid,nloc)
      call lib_barrier()
      t3 = lib_timer()
      call comm_pattern(nproc,mypid,nloc)
      call lib_barrier()
      t4 = lib_timer()
      call get_extern(nproc,mypid,nloc)
      call lib_barrier()
      t5 = lib_timer()
      call put_extern(nproc,mypid,nloc)
      call lib_barrier()
      t6 = lib_timer()
      diag(9) = nput
      diag(10) = nget
c      if (mypid.eq.0) then
c      write(6,*)'time in matvec_ini: total, part 1 - 5 '
c      write(6,'(10x,6f10.5)') t6-t1,t2-t1,t3-t2,t4-t3,t5-t4,t6-t5
c      end if
      call lib_barrier()
      return 
      end


      subroutine get_pattern(nproc,ip,nloc)
      implicit none
      
      integer nproc,ip,nloc
c=============declarations for problem definition=======================
c-------------parameters------------------------------------------------
      INCLUDE "include_parameters"
c------------- data structure for distributed matrix in 
c------------- global address space 
      integer             col(matlen), rpt(veclen+1)
      real                val(matlen)
      common            / matrix / val, col, rpt
c------------- data structure for externel variables in 
c------------- global address space 
      integer             get_list(extlen), get_id(proclen), 
     :                    get_pt(proclen), get_nb(proclen), nget
      integer             put_list(extlen), put_id(proclen),
     :                    put_pt(proclen), put_nb(proclen), nput
      common   / extern / get_list, get_id, get_pt, get_nb, nget, 
     :                    put_list, put_id, put_pt, put_nb, nput

c------------- local variables
      integer nzloc, veclen_loc
      integer ig, igl, l, cl, jpl
      integer iw(proclen)


      nzloc =rpt(1+nloc) - rpt(1) 
      veclen_loc = veclen

      do ig = 1 , nproc
         iw(ig) = -1
         get_id(ig) = -1
      end do
      do l = 1 , nzloc
         cl = col(l)
         jpl = (cl-1) / veclen_loc
         iw(jpl+1) = 1
      end do
      do ig = 1 , nproc-1
         igl = ip + 1 + ig 
         if (igl.gt.nproc) igl = igl - nproc
         if (iw(igl).eq.1) then
            get_id(ig) = igl - 1
         end if
      end do
      nget = nproc - 1

      return 
      end

      subroutine comm_pattern(nproc,ip,nloc)
      implicit none
 
      integer nproc,ip,nloc
      INCLUDE "include_parameters"
c------------- data structure for distributed matrix in 
c------------- global address space 
      integer             col(matlen), rpt(veclen+1)
      real                val(matlen)
      common            / matrix / val, col, rpt
c------------- data structure for externel variables in 
c------------- global address space 
      integer             get_list(extlen), get_id(proclen), 
     :                    get_pt(proclen), get_nb(proclen), nget
      integer             put_list(extlen), put_id(proclen),
     :                    put_pt(proclen), put_nb(proclen), nput
      common   / extern / get_list, get_id, get_pt, get_nb, nget, 
     :                    put_list, put_id, put_pt, put_nb, nput

      integer gets(proclen,0:proclen-1)
      integer puts(proclen,0:proclen-1)
      integer jp, ierr
      integer iget, ig, igg, ipg, maxnget, flag

      maxnget = nget

      do jp = 0 , nproc-1
         call lib_p2p_i(get_id,nget,jp,gets(1,jp),maxnget,0,ierr)
      end do
      call lib_barrier()
      if (ip.eq.0) then
         iget = 1
         do igg = 1 , nproc - 1          
            flag = 0
            do jp = 0 , nproc - 1 
               if (gets(iget,jp).ne.-1) flag = 1
            end do
            if (flag.eq.0) then
               maxnget  = maxnget - 1
               do jp = 0 , nproc - 1
                  do ig = iget , maxnget
                     gets(ig,jp) = gets(ig+1,jp)
                  end do
               end do
            else
               iget = iget + 1
            end if
         end do

         do jp = 0 , nproc - 1
            do ig = 1 , nproc - 1
               puts(ig,jp) = -1
            end do
         end do
      
         do ig = 1 , maxnget
            do jp = 0 , nproc - 1
               ipg = gets(ig,jp)
               if (ipg.ne.-1) then
                  puts(ig,ipg) = jp
               end if
            end do
         end do

      end if
      do jp = 0 , nproc - 1
         call lib_p2p_i(gets(1,jp),maxnget,0,get_id,nget,jp,ierr)
         call lib_p2p_i(puts(1,jp),maxnget,0,put_id,nput,jp,ierr)
      end do

      return
      end
         


      subroutine get_extern(nproc,ip,nloc)
      implicit none
 
      integer nproc, ip, nloc
      INCLUDE "include_parameters"
c------------- data structure for distributed matrix in 
c------------- global address space 
      integer             col(matlen), rpt(veclen+1)
      real                val(matlen)
      common            / matrix / val, col, rpt
c------------- data structure for externel variables in 
c------------- global address space 
      integer             get_list(extlen), get_id(proclen), 
     :                    get_pt(proclen), get_nb(proclen), nget
      integer             put_list(extlen), put_id(proclen),
     :                    put_pt(proclen), put_nb(proclen), nput
      common   / extern / get_list, get_id, get_pt, get_nb, nget, 
     :                    put_list, put_id, put_pt, put_nb, nput

c------------- local variables
      integer veclen_loc, nzloc, ierr
      integer ext_tag(veclen)  
      integer ext_ind, ig, jp, i, l, jpl, cl, cl_loc

      nzloc =rpt(1+nloc) - rpt(1)
      veclen_loc = veclen

      ext_ind = 1
      do ig = 1 , nget 
         get_pt(ig) = ext_ind
         jp = get_id(ig)
         if (jp.ne.-1) then
            do i = 1 , veclen_loc
               ext_tag(i) = 0
            end do
            do l = 1 , nzloc
               cl = col(l)
               jpl = (cl-1) / veclen_loc
               if (jpl.eq.jp) then
                  cl_loc = cl - jp * veclen_loc
                  if (ext_tag(cl_loc).eq.0) then
                     if (nloc+ext_ind.gt.veclen_loc) then
                        write(6,*)
     :                  'nloc+ext_ind greater then veclen_loc'
                        go to 80
                     end if
                     if (ext_ind.gt.extlen) then
                        write(6,*)
     :                  'ext_ind greater then extlen'
                        go to 80
                     end if
                     ext_tag(cl_loc) = ext_ind
                     get_list(ext_ind) = cl_loc
                     ext_ind = ext_ind + 1
                  end if
                  col(l) = jp*veclen_loc + ext_tag(cl_loc)
               end if
            end do
         end if
         get_nb(ig) = ext_ind - get_pt(ig)
         
      end do

      do l = 1 , nzloc
         cl = col(l)
         jp = (cl-1) / veclen_loc
         if (jp.ne.ip) cl = cl + nloc
         col(l) = cl - jp*veclen_loc 
      end do
   80 continue
c      ncomm = ext_ind - 1

      return 
      end

      subroutine put_extern(nproc,mypid,nloc)
      implicit none
 
      integer nproc,mypid,nloc
c=============declarations for problem definition=======================
c-------------parameters------------------------------------------------
      INCLUDE "include_parameters"
c------------- data structure for distributed matrix in 
c------------- global address space 
      integer             col(matlen), rpt(veclen+1)
      real                val(matlen)
      common            / matrix / val, col, rpt
c------------- data structure for externel variables in 
c------------- global address space 
      integer             get_list(extlen), get_id(proclen), 
     :                    get_pt(proclen), get_nb(proclen), nget
      integer             put_list(extlen), put_id(proclen),
     :                    put_pt(proclen), put_nb(proclen), nput
      common   / extern / get_list, get_id, get_pt, get_nb, nget, 
     :                    put_list, put_id, put_pt, put_nb, nput

      integer ig, rp, sp, ia, nrcv, rnb, snb, ierr, i, ip

      ia = 1
      do ig = 1 , nget
         rp = get_id(ig)
         sp = put_id(ig)
         rnb = get_nb(ig)
         call lib_barrier()
         call lib_a2a_i(get_list(get_pt(ig)),rnb,rp,
     :                     put_list(ia),snb,sp,ierr)
         if (sp.eq.-1) snb = 0
         put_pt(ig) = ia
         ia = ia + snb
         put_nb(ig) = snb
         call lib_barrier()
      end do
      call lib_barrier()

      return
      end

      subroutine vars_on_proc(nproc,mypid,nloc,firstrow_on_proc)
      implicit none
      integer nproc, mypid, nloc, firstrow_on_proc(*)

      integer ip, nlocr, ierr

      firstrow_on_proc(1) = 1
      do ip = 0 , nproc-1
         if (mypid.eq.ip) nlocr = nloc
         call lib_brdcst_i(nlocr,1,ip,ierr)
         firstrow_on_proc(ip+2) = firstrow_on_proc(ip+1) + nlocr
      end do

      return
      end



      subroutine matvec_check(rhs,res,x,ipar)
      implicit none
      integer           ipar(*)
      real              rhs(*), res(*), x(*)

      integer ip, nmat, nproc, istat, ioff, nloc, i, iflag, ig, jp
      real              diff

      ipar(12) = 0
c------------- reconstruct dense matrix and reference MATVEC result
      nmat = ipar(2)
      nproc = ipar(6)
      ip = ipar(7)
      call reconstruct(rhs,res,istat,ipar)
      if (istat.lt.0) then
         if (ip.eq.0) write(6,*) 'matvec not checked'
         return
      end if

c------------- check matvec resultg
      ioff = 0
      nloc = ipar(4)
      call lib_barrier()
      call matvec(rhs,x,ipar)
      call lib_barrier()
      iflag = 0
      do i=1, nloc
         diff = abs(res(ioff+i)-x(ioff+i))
         if (diff.gt.1.0e-12) then
            ipar(12) = -2
            iflag = i
            go to 100
         end if
      end do
  100 continue

      do jp = 0 , nproc - 1
         call lib_barrier()
         if (ip.eq.jp) then
            if (iflag.gt.0) then
               write(6,*)
     :     'wrong result on proc. ',ip,' in local index ',iflag
               write(6,*)res(ioff+iflag),x(ioff+iflag)
            else
               write(6,*) 'matvec check passed on proc',ip
            end if
         end if
         call lib_barrier()
      end do

      return
      end

      subroutine reconstruct(rhs,res,istat,ipar)
      implicit none

c=============declarations for problem definition=======================
      INCLUDE "include_parameters"
c------------- data structure for distributed matrix in 
c------------- global address space 
      integer             col(matlen), rpt(veclen+1)
      real                val(matlen)
      common            / matrix / val, col, rpt
c------------- data structure for externel variables in 
c------------- global address space 
      integer             get_list(extlen), get_id(proclen), 
     :                    get_pt(proclen), get_nb(proclen), nget
      integer             put_list(extlen), put_id(proclen),
     :                    put_pt(proclen), put_nb(proclen), nput
      common   / extern / get_list, get_id, get_pt, get_nb, nget, 
     :                    put_list, put_id, put_pt, put_nb, nput

      real              rhs(*), res(*)

      integer ipar(*), istat

      integer la_max
      parameter (la_max = 100)
    
      real              a(la_max,la_max), b(la_max), c(la_max)
      real              al(la_max,la_max)
c------------- local variables
      integer firstrow_on_proc(proclen+1)
      integer nmat, nproc, ierr
      integer lv_s, lv_g, colg, coll, cols, nloc, nrecv, nlocr
      integer lel_g, lep_g, lel, nelp, ext_ind, ia, ie
      integer i, l, mypid, jp, kp, lp, is, il, io, ioff, ig, la2

      istat = 0
      nmat = ipar(2)
      nproc = ipar(6)
      mypid = ipar(7)
      nloc = ipar(4)
      if (nmat.gt.la_max) then
         istat = -2
         return
      end if
      call vars_on_proc(nproc,mypid,nloc,firstrow_on_proc) 
      ioff = firstrow_on_proc(mypid+1)-1

         do l = 1 , la_max
            do i = 1 , la_max
               a(i,l) = 0.0
               al(i,l) = 0.0
            end do
         end do

      do jp = 0 , nproc-1
         io = firstrow_on_proc(jp+1)-1
         call lib_p2p_s(rhs,nloc,jp,b(1+io),nrecv,0,ierr)
      end do
      do i = 1 , nloc
         do l = rpt(i) ,  rpt(i+1)-1
            colg = col(l) 
            if (colg.le.nloc) then
               kp = mypid
               coll = colg
            else
               ext_ind = colg - nloc
               lel = 0
               do ig = 1 , nget
                  ia =  get_pt(ig)
                  nelp =  get_nb(ig)
                  if(lel+nelp.ge.ext_ind) then
                     kp = get_id(ig)
                     coll = get_list(ext_ind) 
                     go to 100
                  end if
                  lel = lel + nelp
               end do
  100          continue
            end if
            cols = firstrow_on_proc(kp+1)-1 + coll
            al(i+ioff,cols) = val(l)
         end do
      end do
      la2 = la_max**2
      do jp = 0 , nproc-1
         call lib_p2p_s(al,la2,jp,al,la2,0,ierr)
         if (mypid.eq.0) then
            do l = 1 , la_max
               do i = 1 , la_max
                  a(i,l) = a(i,l) + al(i,l)
               end do
            end do
         end if
         call lib_barrier()
      end do

      if (mypid.eq.0) then
         if (nmat.le.20) then
            write(6,*)'matrix======================'
            do i = 1 , nmat
               write(6,198)(a(i,l),l=1,nmat)
            end do
            write(6,*)'right hand side ======================'
            write(6,199)(b(l),l=1,nmat)
  198       format(20e9.2)
  199       format(20e9.2)
         end if

         do i = 1 , nmat
            c(i) = 0.0
            do l = 1 , nmat
               c(i) = c(i) + a(i,l) * b(l)
            end do
         end do
      end if

      call lib_barrier()
      do jp = 0 , nproc-1
         io = firstrow_on_proc(jp+1)-1
         nlocr = firstrow_on_proc(jp+2) - firstrow_on_proc(jp+1)
         call lib_p2p_s(c(1+io),nlocr,0,res,nloc,jp,ierr)
      end do
      call lib_barrier()
      return
      end
